require 'lib/controller'
require 'lib/controller/default'
require 'lib/controller/routecontroller'
require 'lib/popup'

class BuyMenuController < Controller
  def BuyMenuController.handle(event)
    case event
      when MouseDownEvent
        BuyMenu.instance.buttons.each do |button|
          if button.rect.collide_point?(*event.pos)
            button.click
            BuyMenu.instance.hide
            RouteOverlay.instance.reset
            RouteOverlay.instance.show
            Controller.change_to(RouteController)
            break
          end
        end
        trucks = TruckOverlay.instance
        if trucks.rect.collide_point?(*event.pos)
          Controller.change_to(DefaultController)
          Settings.instance[:paused] = false
          BuyMenu.instance.hide
        end
      when KeyDownEvent
        case event.key
          when K_ESCAPE
            Controller.change_to(DefaultController)
            Settings.instance[:paused] = false
            BuyMenu.instance.hide
        end
    end
  end
end
