require 'lib/controller'
require 'lib/controller/buymenucontroller'
require 'lib/controller/quitcontroller'
require 'lib/popup'

class DefaultController < Controller
  def DefaultController.handle(event)
    case event
      when MouseMotionEvent
        sroverlay = ShowRouteOverlay.instance
        sroverlay.mouse_at(*event.pos) if sroverlay.visible?
      when MouseDownEvent
        sroverlay = ShowRouteOverlay.instance
        if sroverlay.click_at(*event.pos) and sroverlay.visible?
          Controller.change_to(RouteController)
          RouteOverlay.instance.reset
          RouteOverlay.instance.show
          return
        end
        sroverlay.hide
        
        trucks = TruckOverlay.instance
        if trucks.rect.collide_point?(*event.pos)
          if BuyMenu.instance.show
            popup = Popup.instance
            popup.city.toggle_info if popup.visible?
            Settings.instance[:paused] = true
            Controller.change_to(BuyMenuController)
          end
          return
        end
        trucks = Company.instance.trucks
        trucks.each do |truck|
          if truck.rect.collide_point?(*event.pos)
            if sroverlay.visible?
              sroverlay.hide
            else
              sroverlay.show(truck)
            end
          end
        end
        Controller.context["map"].cities.each do |city|
          if city.rect.collide_point?(*event.pos)
            city.toggle_info
            return
          end
          popup = Popup.instance
          if popup.visible?
            popup.visible=false
          end
        end
      when KeyDownEvent
        case event.key
          when K_ESCAPE
            popup = Popup.instance
            if popup.visible?
              popup.city.toggle_info
            elsif ShowRouteOverlay.instance.visible?
              ShowRouteOverlay.instance.hide
            else
              QuitOverlay.instance.show
              Controller.change_to(QuitController)
            end
        end
    end
  end
end
