require 'lib/controller'
require 'lib/controller/default'
require 'lib/controller/cargocontroller'
require 'lib/popup'

class RouteController < Controller
  def RouteController.handle(event)
    case event
      when MouseDownEvent
        Controller.context["map"].cities.each do |city|
          if city.rect.collide_point?(*event.pos)
            RouteOverlay.instance.add_stop(city)
            RouteOverlay.instance.hide
            Controller.change_to(CargoController)
            CargoOverlay.instance.show(city)
            return
          end
        end
      when MouseMotionEvent
        RouteOverlay.instance.mouse_at(*event.pos)
      when KeyDownEvent
        case event.key
          when 13 # Enter
            cargo = RouteOverlay.instance.cargo
            stops =  RouteOverlay.instance.stops
            cargo_t = {}
            cargo.each_with_index { |c,i|cargo_t[stops[i]] = c }
            stops.pop if stops[0] == stops[stops.size-1]
            stops = Controller.context["map"].fix_route(stops)
            Company.instance.add_truck(stops,cargo_t)
            Controller.change_to(DefaultController)
            RouteOverlay.instance.hide
            Settings.instance[:paused] = false
        end
    end
  end
end
